/*
 * MyeongWol Controller Firmware
 * by Bizan Nishimura
 */
 
/*GR-SAKURA Sketch Template Version: V1.01*/
#include <rxduino.h>
#include <servo.h>
#include "steppers.h"
#include "common.h"

/* 0x02/0x03ƃfobOɂ̂ŁA#/$  dJn/I Ɏg */
/** dJn */
#define CODE_STX '#'
/** dI */
#define CODE_ETX '$'
/** dJn҂ */
#define STATE_READY     0
/** dM */
#define STATE_RECEIVING 1

/**
 * T[{
 * [0]:Waist [1]:Neck [2]:Arm-L1 [3]:Arm-L2 [4]:Arm-R1 [5]:Arm-R2
 */
Servo servos[6];

/**
 * 
 */
void setup()
{
    // VAʐM̐ݒ
    // IO0(P21):RxD, IO1(P20):TxD */
    Serial.begin(19200,SCI_SCI0P2x);
    //Serial.println("Annyeong haseyo!");
    
    // XebsO[^̐ݒ
    // IO6:nEnable, IO5:L-Clk, IO4:L-Dir, IO3:R-Clk, IO2:R-Dir
    steppers_init(6,5,4,3,2);
    steppers_enable();
    steppers_stop();
    
    // T[{̐ݒ
    pinMode(7,OUTPUT); // IO7:Servo Enable (High Active)
    digitalWrite(7,  1);
    servos[0].attach(13); // IO13:Waist
    servos[1].attach(12); // IO12:Neck
    servos[2].attach(9);  // IO9:Arm-L1
    servos[3].attach(8);  // IO8:Arm-L2
    servos[4].attach(11); // IO11:Arm-R1
    servos[5].attach(10); // IO10:Arm-R2
    // T[{̏px
    servos[0].write(90);
    servos[1].write(90);
    servos[2].write(90);
    servos[3].write(90);
    servos[4].write(90);
    servos[5].write(90);
}

/**
 * MR}h̎s
 *
 * @param buff MR}hւ̃|C^
 */
void execute_command(char* buff)
{
    int servoNum;
    unsigned short val;
    
    switch(buff[0])
    {
    /* T[{R}h */
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
        //Serial.println("SERVO ");
        /* T[{ԍ */
        servoNum = (int)(buff[0] - '1');
        /* wߊpxL(180ȉ)Ȃݒ */
        if( DecToUint16(&buff[1], &val, 3) == 0 )
        {
            if( val<=180 )
            {
                //Serial.println("DEG ");
                if(servoNum==3 || servoNum==4 || servoNum==5)
                {
                    val = 180 - val;
                }
                servos[servoNum].write(val);
            }
        }
        break;
    
    /* OiR}h */
    case 'F':
        //steppers_forward(2);
        /* wߑxL(10ȉ)Ȃݒ */
        if( DecToUint16(&buff[1], &val, 2) == 0 )
        {
            if( val<=10 )
            {
                steppers_forward(val);
            }
        }
        break;
        
    /* ރR}h */
    case 'B':
        //steppers_backward(2);
        /* wߑxL(10ȉ)Ȃݒ */
        if( DecToUint16(&buff[1], &val, 2) == 0 )
        {
            if( val<=10 )
            {
                steppers_backward(val);
            }
        }
        break;
        
    /* ]R}h */
    case 'L':
        //steppers_turnLeft(2);
        /* wߑxL(10ȉ)Ȃݒ */
        if( DecToUint16(&buff[1], &val, 2) == 0 )
        {
            if( val<=10 )
            {
                steppers_turnLeft(val);
            }
        }
        break;
        
    /* E]R}h */
    case 'R':
        //steppers_turnRight(2);
        /* wߑxL(10ȉ)Ȃݒ */
        if( DecToUint16(&buff[1], &val, 2) == 0 )
        {
            if( val<=10 )
            {
                steppers_turnRight(val);
            }
        }
        break;
    
    /* ~R}h */
    case 'S':
        steppers_stop();
        break;
    }
}

/**
 * C[v
 */
void loop()
{
    char c;
    static int state = STATE_READY;
    static int ptr=0;
    static char buff[16];
    
    /* VAMf[^邩H */
    if (Serial.available() > 0)
    {
        //Serial.println("RECV ");
        c = Serial.read();
        switch(state)
        {
        /* dJn҂ */
        case STATE_READY:
            /* dJnR[hdMԂ */
            if(c == CODE_STX)
            {
                //Serial.println("STX ");
                state = STATE_RECEIVING;
                ptr = 0;
            }
            break;
        /* dM */
        case STATE_RECEIVING:
            /* dJnR[hM̃f[^j */
            if(c == CODE_STX)
            {
                //Serial.println("STX ");
                ptr = 0;
            }
            /* dIR[hAMd̃R}hs */
            else if(c == CODE_ETX)
            {
                //Serial.println("ETX ");
                execute_command(buff);
                state = STATE_READY;
            }
            /* 1M */
            else
            {
                buff[ptr] = c;
                ptr++;
                if(ptr>=16)
                {
                    state = STATE_READY;
                }
            }
            break;
        default:
            state = STATE_READY;
        }
    }
}

